//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include <cstdlib>
#include <iostream>

using namespace std;

//----------------------------------------------------------------------------

// there's a predefined function called swap(), so don't use that

template<typename T>
void myswap(T & a, T & b)
{
  T temp;

  temp = a;
  a = b;
  b = temp;
}

//----------------------------------------------------------------------------

template<typename T>
T findsmallest(T A[], int size)
{
  int i;
  T smallest_so_far;

  smallest_so_far = A[0];
  for (i = 1; i < size; i++)
    if (A[i] < smallest_so_far)
      smallest_so_far = A[i];

  return smallest_so_far;
}

//----------------------------------------------------------------------------

void example1()
{
  // integers

  int x = 1;
  int y = 5;
  
  cout << "before: " << x << " " << y << endl;
  myswap(x, y);
  cout << "after: " << x << " " << y << endl;

  // chars

  char u = '!';
  char v = '?';

  cout << "before: " << u << " " << v << endl;
  myswap(u, v);
  cout << "after: " << u << " " << v << endl;

  // strings (classes!)

  string s = "hoo";
  string t = "ray";

  cout << "before: " << s << " " << t << endl;
  myswap(s, t);
  cout << "after: " << s << " " << t << endl;
}

//----------------------------------------------------------------------------

void example2()
{
  int A[5] = { 7, 9, 2, 10, 23 };


  string S[6] = { "umbrella",
		  "stingray",
		  "bicycle",
		  "aardvark",
		  "AARDVARK",
		  "rainbow" };

  cout << findsmallest(A, 5) << endl;
  cout << findsmallest(S, 6) << endl;
}

//----------------------------------------------------------------------------

int main(int argc, char** argv)
{
  //  example1();

  example2();
  
  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
